const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class VendorsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const vendors = await db.vendors.create(
      {
        id: data.id || undefined,

        name: data.name || null,
        tax_id: data.tax_id || null,
        country: data.country || null,
        currency: data.currency || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await vendors.setOrganizations(data.organizations || null, {
      transaction,
    });

    return vendors;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const vendorsData = data.map((item, index) => ({
      id: item.id || undefined,

      name: item.name || null,
      tax_id: item.tax_id || null,
      country: item.country || null,
      currency: item.currency || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const vendors = await db.vendors.bulkCreate(vendorsData, { transaction });

    // For each item created, replace relation files

    return vendors;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const vendors = await db.vendors.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.name !== undefined) updatePayload.name = data.name;

    if (data.tax_id !== undefined) updatePayload.tax_id = data.tax_id;

    if (data.country !== undefined) updatePayload.country = data.country;

    if (data.currency !== undefined) updatePayload.currency = data.currency;

    updatePayload.updatedById = currentUser.id;

    await vendors.update(updatePayload, { transaction });

    if (data.organizations !== undefined) {
      await vendors.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return vendors;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const vendors = await db.vendors.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of vendors) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of vendors) {
        await record.destroy({ transaction });
      }
    });

    return vendors;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const vendors = await db.vendors.findByPk(id, options);

    await vendors.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await vendors.destroy({
      transaction,
    });

    return vendors;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const vendors = await db.vendors.findOne({ where }, { transaction });

    if (!vendors) {
      return vendors;
    }

    const output = vendors.get({ plain: true });

    output.bills_vendor = await vendors.getBills_vendor({
      transaction,
    });

    output.organizations = await vendors.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('vendors', 'name', filter.name),
        };
      }

      if (filter.tax_id) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('vendors', 'tax_id', filter.tax_id),
        };
      }

      if (filter.country) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('vendors', 'country', filter.country),
        };
      }

      if (filter.currency) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('vendors', 'currency', filter.currency),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.vendors.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('vendors', 'name', query),
        ],
      };
    }

    const records = await db.vendors.findAll({
      attributes: ['id', 'name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.name,
    }));
  }
};
